<?xml version="1.0"?>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:axsl="http://www.w3.org/1999/XSL/TransformAlias"
  xmlns:template="http://www.boddie.org.uk/ns/xmltools/template"
  xmlns:dyn="http://exslt.org/dynamic"
  extension-element-prefixes="dyn">

  <xsl:output indent="yes"/>
  <xsl:namespace-alias stylesheet-prefix="axsl" result-prefix="xsl"/>

  <xsl:param name="element-id"/>



  <!-- Start at the top, finding only the specified element. -->

  <xsl:template match="/">
    <axsl:stylesheet version="1.0"
      xmlns:dyn="http://exslt.org/dynamic"
      extension-element-prefixes="dyn">

      <axsl:output indent="yes"/>
      <axsl:param name="element-path"/>

      <!-- NOTE: Hard-coded doctypes to hopefully satisfy JavaScript code. -->
      <!-- doctype-public="-//W3C//DTD XHTML 1.1//EN"
        doctype-system="http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd" -->

      <axsl:template match="/">

        <!-- Include the remaining attributes. -->
        <xsl:apply-templates select="@*"/>

        <!-- Process the elements. -->
        <axsl:for-each select="dyn:evaluate($element-path)">
          <xsl:for-each select="//*[@id=$element-id]">
            <xsl:copy>
              <xsl:apply-templates select="@*|node()"/>
            </xsl:copy>
          </xsl:for-each>
        </axsl:for-each>

      </axsl:template>
    </axsl:stylesheet>
  </xsl:template>



  <!-- Replicate unknown elements. -->

  <xsl:template match="@*|node()">
    <xsl:copy>
      <xsl:apply-templates select="@*|node()"/>
    </xsl:copy>
  </xsl:template>

</xsl:stylesheet>
